// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Comecocos.h"
#include "ComecocosDoc.h"

#include "MainFrm.h"
#include "Dialogo_opciones.h"
//#include "DialogoFinJuego.h"
#include "DialogoRecord.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_COMMAND(IDM_30, On30)
   ON_COMMAND(IDM_35, On35)
	ON_COMMAND(IDM_40, On40)
	ON_COMMAND(IDM_45, On45)
	ON_COMMAND(IDM_OPCIONES, OnOpciones)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{	
}

CMainFrame::~CMainFrame()
{
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs


   SetTitle("Super Pacman");


	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

CDocument* CMainFrame::GetActiveDocument() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFrameWnd::GetActiveDocument();
}


//**********************************************************************************************//
//*               Clicka la opcion de velocidad del menu q tengamos por defecto                *//
//**********************************************************************************************//
void CMainFrame::activaMenu() 
{
	CComecocosDoc* pDoc = (CComecocosDoc*) GetActiveDocument();

   CMenu *mmenu = GetMenu();
   CMenu *submenu = mmenu->GetSubMenu(1); //Opciones
   mmenu = submenu->GetSubMenu(1); //Velocidad

   if (pDoc->TIMER == 30) mmenu -> CheckMenuItem(IDM_30, MF_CHECKED); 
   else if (pDoc->TIMER == 35) mmenu -> CheckMenuItem(IDM_35, MF_CHECKED);
   else if (pDoc->TIMER == 40) mmenu -> CheckMenuItem(IDM_40, MF_CHECKED);
   else if (pDoc->TIMER == 45) mmenu -> CheckMenuItem(IDM_45, MF_CHECKED);
}


//**********************************************************************************************//
//*                          Si cambiamos la velocidad a 30 ms                                 *//
//**********************************************************************************************//
void CMainFrame::On30() 
{
	CComecocosDoc* pDoc = (CComecocosDoc*) GetActiveDocument();
	pDoc->TIMER = 30;

   CMenu *mmenu = GetMenu();
   CMenu *submenu = mmenu->GetSubMenu(1); //Opciones
   mmenu = submenu->GetSubMenu(1); //Velocidad

   mmenu -> CheckMenuItem(IDM_30, MF_CHECKED); // | MF_DISABLED);
   mmenu -> CheckMenuItem(IDM_35, MF_UNCHECKED); // | MF_DISABLED);
   mmenu -> CheckMenuItem(IDM_40, MF_UNCHECKED); // | MF_DISABLED);
   mmenu -> CheckMenuItem(IDM_45, MF_UNCHECKED); // | MF_DISABLED);
}


//**********************************************************************************************//
//*                          Si cambiamos la velocidad a 35 ms                                 *//
//**********************************************************************************************//
void CMainFrame::On35() 
{
	CComecocosDoc* pDoc = (CComecocosDoc*) GetActiveDocument();
	pDoc->TIMER = 35;
	
   CMenu *mmenu = GetMenu();
   CMenu *submenu = mmenu->GetSubMenu(1); //Opciones
   mmenu = submenu->GetSubMenu(1); //Velocidad

   mmenu -> CheckMenuItem(IDM_35, MF_CHECKED); // | MF_DISABLED);
   mmenu -> CheckMenuItem(IDM_30, MF_UNCHECKED); // | MF_DISABLED);
   mmenu -> CheckMenuItem(IDM_40, MF_UNCHECKED); // | MF_DISABLED);
   mmenu -> CheckMenuItem(IDM_45, MF_UNCHECKED); // | MF_DISABLED);
}

//**********************************************************************************************//
//*                          Si cambiamos la velocidad a 40 ms                                 *//
//**********************************************************************************************//
void CMainFrame::On40() 
{
	CComecocosDoc* pDoc = (CComecocosDoc*) GetActiveDocument();
	pDoc->TIMER = 40;

   CMenu *mmenu = GetMenu();
   CMenu *submenu = mmenu->GetSubMenu(1); //Opciones
   mmenu = submenu->GetSubMenu(1); //Velocidad

   mmenu -> CheckMenuItem(IDM_40, MF_CHECKED); // | MF_DISABLED);
   mmenu -> CheckMenuItem(IDM_35, MF_UNCHECKED); // | MF_DISABLED);
   mmenu -> CheckMenuItem(IDM_30, MF_UNCHECKED); // | MF_DISABLED);
   mmenu -> CheckMenuItem(IDM_45, MF_UNCHECKED); // | MF_DISABLED);
}


//**********************************************************************************************//
//*                          Si cambiamos la velocidad a 45 ms                                 *//
//**********************************************************************************************//
void CMainFrame::On45() 
{
	CComecocosDoc* pDoc = (CComecocosDoc*) GetActiveDocument();
	pDoc->TIMER = 45;	

   CMenu *mmenu = GetMenu();
   CMenu *submenu = mmenu->GetSubMenu(1); //Opciones
   mmenu = submenu->GetSubMenu(1); //Velocidad

   mmenu -> CheckMenuItem(IDM_45, MF_CHECKED); // | MF_DISABLED);
   mmenu -> CheckMenuItem(IDM_35, MF_UNCHECKED); // | MF_DISABLED);
   mmenu -> CheckMenuItem(IDM_40, MF_UNCHECKED); // | MF_DISABLED);
   mmenu -> CheckMenuItem(IDM_30, MF_UNCHECKED); // | MF_DISABLED);
}


//**********************************************************************************************//
//*                          Si abrimos el menu de opciones                                    *//
//**********************************************************************************************//
void CMainFrame::OnOpciones() 
{
	CDialogo_opciones midialogo;
   char pantallaChar[5];
   int pantallaInt;

	CComecocosDoc* pDoc = (CComecocosDoc*) GetActiveDocument();

   itoa(pDoc->PANTALLA, pantallaChar, 10);
	midialogo.m_pantalla = pantallaChar;

	midialogo.m_vidas = pDoc->VIDAS-1;
   midialogo.m_dificultad = pDoc->DIFICULTAD;
   midialogo.m_maxPantallas = pDoc->MAX_PANTALLAS;
   midialogo.m_graficos3D = (pDoc->GRAFICOS == 1);

	midialogo.DoModal();


	pDoc->VIDAS = midialogo.m_vidas+1;
   pantallaInt = atoi(midialogo.m_pantalla);
   if (pantallaInt > 0 && pantallaInt <= pDoc->MAX_PANTALLAS) pDoc->PANTALLA = pantallaInt;
	pDoc->DIFICULTAD = midialogo.m_dificultad;
   pDoc->GRAFICOS = midialogo.m_graficos3D;

	InvalidateRect(NULL, true);	
}

