#if !defined(AFX_COMECOCOSVIEW_H__93AD0476_BECB_45DD_92ED_B9C2DA980075__INCLUDED_)
#define AFX_COMECOCOSVIEW_H__93AD0476_BECB_45DD_92ED_B9C2DA980075__INCLUDED_


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CComecocosView : public CView
{
   //********************************//
   //*** Declaracion de atributos ***//
   //********************************//
   private:
      int oldTimer;
      bool relojActivo;
      bool pantallaBorrada;

      //Variables para almacenar los Bitmaps
      CBitmap Btiles; // Almacena los tiles del mapa
      CBitmap Bfantasmas; // Almacena los fantasmas
      CBitmap Bpacman; //Almacena los pacmans


   //******************************//
   //*** Declaracion de metodos ***//
   //******************************//

   protected: // create from serialization only
      CComecocosView();
      DECLARE_DYNCREATE(CComecocosView)

   private:
      void dibujaMapaPantalla(); //Dibuja el mapa de pantalla del juego
      void dibujaPersonajes(); //Dibuja los personajes en la pantalla
      void dibujaFrase(char f);
      void cambiaPuertas();
      void setTimer(int ms);
      void dibujaPuntuaciones();
      void cambiaGraficos();


      bool oldGraficos3D;


   public:
      CComecocosDoc* GetDocument();
   	virtual ~CComecocosView();

      // Overrides
	   // ClassWizard generated virtual function overrides
	   //{{AFX_VIRTUAL(CComecocosView)
	   public:
	      virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	      virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	   protected:
	      //}}AFX_VIRTUAL

   public:
      #ifdef _DEBUG
	      virtual void AssertValid() const;
	      virtual void Dump(CDumpContext& dc) const;
      #endif

   // Generated message map functions
   protected:
      //{{AFX_MSG(CComecocosView)
      afx_msg void OnTimer(UINT nIDEvent);
      afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
      afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnDestroy();
	//}}AFX_MSG
      DECLARE_MESSAGE_MAP()
};


#ifndef _DEBUG  // debug version in ComecocosView.cpp
inline CComecocosDoc* CComecocosView::GetDocument()
   { return (CComecocosDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_COMECOCOSVIEW_H__93AD0476_BECB_45DD_92ED_B9C2DA980075__INCLUDED_)
